package se.nekotronic.readypingbounceserver;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ClientTalkerThread extends Thread {
	// private final MainServerThread owner;
	private final BufferedReader from_client;
	final PrintWriter to_client;
	private static int instances = 0;
	private int number = ++instances;
	private final SimpleLogger logger = new SimpleLogger("ConnectionWaiterThread " + number);
	private boolean quit = false;

	public ClientTalkerThread(BufferedReader from_client, PrintWriter to_client) {
		// this.owner = owner;
		this.from_client = from_client;
		this.to_client = to_client;
	}

	public void run() {
		while (! quit) {
			String line_from_client;
			try {
				line_from_client = from_client.readLine();
				logger.log("Frn klienten: " + line_from_client);
				if (line_from_client.equals("HELLO")) {
					logger.log("Got HELLO");
					send("HELLO");
				}
				else if (line_from_client.equals("BYE")) {
					logger.log("Got BYE");
					send("BYE");
					from_client.close();
					to_client.close();
					quit = true;
				}
				else if (line_from_client.startsWith("PING ")) {
					logger.log("Got PING");
					String rest_of_line = line_from_client.substring(5);
					send("PONG " + rest_of_line);
				}
				else if (line_from_client.startsWith("REPORT ")) {
					logger.log("Got REPORT");
					report(line_from_client);
					send("REPORT OK");
				}
				else {
					logger.log("Got invalid line: '" + line_from_client + "'");
					send("ERROR");
				}
			}
			catch (IOException e) {
				logger.log("Tappat kontakten med klienten.");
				e.printStackTrace();
				quit = true;
			}
		} // while
		// owner.client_has_disconneted(this);
	} // run

	private void report(String report_line) {
		logger.log("Got a REPORT line: " + report_line);
		try {
		    PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("pingreports.txt", true)));
            Date now = new Date();
            final SimpleDateFormat date_format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS Z");
			String formatted_date = date_format.format(now);
            String line = "Report: " + formatted_date + ": " + report_line;
		    out.println(line);
		    out.close();
		} catch (IOException e) {
		    logger.log("Writing report failed: e = " + e.getMessage());
		}
	}

	public void send(String line) {
		to_client.println(line);
	}
} // class ClientListenerThread
